require 'nokogiri'
require 'zip'
require 'digest/md5'

class GemTestInner

  def self.speak
    puts "GemTest here.\narf!"
  end

end

class Workbook

  attr_reader :name, :dir, :modtime, :version, :build, :ndoc

  def initialize twbWithDir
    file     = File.new(twbWithDir)
    @name    = File.basename(twbWithDir)
    @dir     = File.dirname(File.expand_path(twbWithDir))
    @modtime = File.new(twbWithDir).mtime
    @ndoc = Nokogiri::XML(open(twbWithDir))
    @version = @ndoc.xpath('/workbook/@version')
    @build   = @ndoc.xpath('/workbook/comment()').text.gsub(/^[^0-9]+/,'').strip
  end

end #class Workbook


# Tableau Workbook <datasource XML node
# =====================================
class DataSource

  @@hasher = Digest::SHA256.new

  attr_reader :node, :name, :caption, :uiname, :connHash, :class, :connection

  def initialize dataSourceNode
    @node    = dataSourceNode
    @name    = @node.xpath('./@name').text
    @caption = @node.xpath('./@caption').text
    @uiname  = if @caption.nil? || @caption == '' then @name else @caption end
    # puts "DS:        n:#{@name}"
    # puts "     caption:#{@caption}"
    # puts "      c.len :#{@caption.length}"
    # puts "      c.nil?:#{@caption.nil?}"
    # puts "      uiname:#{@uiname}"
    # puts " "
    processConnection
  end

  def processConnection
    @connHash    = ''
    @connection  = @node.at_xpath('./connection')
    if !@connection.nil? then
      @class       = @connection.attribute('class').text
      dsAttributes = @node.xpath('./connection/@*')
      dsConnStr  = ''
      dsAttributes.each do |attr|
        dsConnStr += attr.text
        # Note: only collects non-'' attribute values
      end
      @connHash = Digest::MD5.hexdigest(dsConnStr)
    end
  end

end #class DataSource